// *************************************
// ** ZXpandMouse.h                   **
// ** Class Definitions               **
// *************************************

class MouseRptParser : public MouseReportParser
{
	protected:
		void OnMouseMove		(MOUSEINFO *mi);
		void OnLeftButtonUp		(MOUSEINFO *mi);
		void OnLeftButtonDown	(MOUSEINFO *mi);
		void OnRightButtonUp	(MOUSEINFO *mi);
		void OnRightButtonDown	(MOUSEINFO *mi);


	public:
		// Keep track of last mouse movement by direction
		// Up, Down, Left, Right, Fire
		long plMovedLastMills[5];

};
void MouseRptParser::OnMouseMove(MOUSEINFO *mi)
{

	if(mi->dY != 0){
		if(mi->dY < -1){
			//Serial.println(" UP");
			// Get milliseconds since turn on. Used to comapre times for debounce
			plMovedLastMills[0] = millis();
		} else if(mi->dY > 1){
			//Serial.println(" DOWN");
			// Get milliseconds since turn on. Used to comapre times for debounce
			plMovedLastMills[1] = millis();
		}
	}

	if(mi->dX != 0){
		if(mi->dX < -1){
			//Serial.println(" LEFT");
			plMovedLastMills[2] = millis();
		} else if(mi->dX > 1){
			//Serial.println(" RIGHT");
			plMovedLastMills[3] = millis();
		}
	}


};
// Simple button press
void MouseRptParser::OnLeftButtonUp	(MOUSEINFO *mi)
{
    plMovedLastMills[4] = false;
};
void MouseRptParser::OnLeftButtonDown	(MOUSEINFO *mi)
{
    plMovedLastMills[4] = true;
};
void MouseRptParser::OnRightButtonUp	(MOUSEINFO *mi)
{
    plMovedLastMills[4] = false;
};
void MouseRptParser::OnRightButtonDown	(MOUSEINFO *mi)
{
    plMovedLastMills[4] = true;
};


